/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.299 Revision 1.349
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.299 2008/02/20 17:32:02 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.349 2010/08/19 21:32:26 vapier Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
17 17
18inherit multilib portability 18inherit multilib portability
19 19
20DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
21 21
22if has "${EAPI:-0}" 0 1 2; then
23
22# @FUNCTION: epause 24# @FUNCTION: epause
23# @USAGE: [seconds] 25# @USAGE: [seconds]
24# @DESCRIPTION: 26# @DESCRIPTION:
25# Sleep for the specified number of seconds (default of 5 seconds). Useful when 27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
26# printing a message the user should probably be reading and often used in 28# printing a message the user should probably be reading and often used in
27# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set, 29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
28# don't wait at all. 30# don't wait at all. Defined in EAPIs 0 1 and 2.
29epause() { 31epause() {
30 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
31} 33}
32 34
33# @FUNCTION: ebeep 35# @FUNCTION: ebeep
34# @USAGE: [number of beeps] 36# @USAGE: [number of beeps]
35# @DESCRIPTION: 37# @DESCRIPTION:
36# Issue the specified number of beeps (default of 5 beeps). Useful when 38# Issue the specified number of beeps (default of 5 beeps). Useful when
37# printing a message the user should probably be reading and often used in 39# printing a message the user should probably be reading and often used in
38# conjunction with the epause function. If the EBEEP_IGNORE env var is set, 40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
39# don't beep at all. 41# don't beep at all. Defined in EAPIs 0 1 and 2.
40ebeep() { 42ebeep() {
41 local n 43 local n
42 if [[ -z ${EBEEP_IGNORE} ]] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
43 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
44 echo -ne "\a" 46 echo -ne "\a"
47 sleep 1 49 sleep 1
48 done 50 done
49 fi 51 fi
50} 52}
51 53
54else
55
56ebeep() {
57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
58}
59
60epause() {
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62}
63
64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to einfo for package managers that don't provide eqawarn and use the PM
70# implementation if available.
71if ! declare -F eqawarn >/dev/null ; then
72 eqawarn() {
73 einfo "$@"
74 }
75fi
76
52# @FUNCTION: ecvs_clean 77# @FUNCTION: ecvs_clean
53# @USAGE: [list of dirs] 78# @USAGE: [list of dirs]
54# @DESCRIPTION: 79# @DESCRIPTION:
55# Remove CVS directories recursiveley. Useful when a source tarball contains 80# Remove CVS directories recursiveley. Useful when a source tarball contains
56# internal CVS directories. Defaults to $PWD. 81# internal CVS directories. Defaults to $PWD.
68esvn_clean() { 93esvn_clean() {
69 [[ -z $* ]] && set -- . 94 [[ -z $* ]] && set -- .
70 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf 95 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
71} 96}
72 97
73# Default directory where patches are located 98# @FUNCTION: eshopts_push
99# @USAGE: [options to `set` or `shopt`]
100# @DESCRIPTION:
101# Often times code will want to enable a shell option to change code behavior.
102# Since changing shell options can easily break other pieces of code (which
103# assume the default state), eshopts_push is used to (1) push the current shell
104# options onto a stack and (2) pass the specified arguments to set.
105#
106# If the first argument is '-s' or '-u', we assume you want to call `shopt`
107# rather than `set` as there are some options only available via that.
108#
109# A common example is to disable shell globbing so that special meaning/care
110# may be used with variables/arguments to custom functions. That would be:
111# @CODE
112# eshopts_push -o noglob
113# for x in ${foo} ; do
114# if ...some check... ; then
115# eshopts_pop
116# return 0
117# fi
118# done
119# eshopts_pop
120# @CODE
121eshopts_push() {
122 # have to assume __ESHOPTS_SAVE__ isn't screwed with
123 # as a `declare -a` here will reset its value
124 local i=${#__ESHOPTS_SAVE__[@]}
125 if [[ $1 == -[su] ]] ; then
126 __ESHOPTS_SAVE__[$i]=$(shopt -p)
127 [[ $# -eq 0 ]] && return 0
128 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
129 else
130 __ESHOPTS_SAVE__[$i]=$-
131 [[ $# -eq 0 ]] && return 0
132 set "$@" || die "eshopts_push: bad options to set: $*"
133 fi
134}
135
136# @FUNCTION: eshopts_pop
137# @USAGE:
138# @DESCRIPTION:
139# Restore the shell options to the state saved with the corresponding
140# eshopts_push call. See that function for more details.
141eshopts_pop() {
142 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
143 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
144 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
145 local s=${__ESHOPTS_SAVE__[$i]}
146 unset __ESHOPTS_SAVE__[$i]
147 if [[ ${s} == "shopt -"* ]] ; then
148 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
149 else
150 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
151 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
152 fi
153}
154
155# @VARIABLE: EPATCH_SOURCE
156# @DESCRIPTION:
157# Default directory to search for patches.
74EPATCH_SOURCE="${WORKDIR}/patch" 158EPATCH_SOURCE="${WORKDIR}/patch"
75# Default extension for patches 159# @VARIABLE: EPATCH_SUFFIX
160# @DESCRIPTION:
161# Default extension for patches (do not prefix the period yourself).
76EPATCH_SUFFIX="patch.bz2" 162EPATCH_SUFFIX="patch.bz2"
163# @VARIABLE: EPATCH_OPTS
164# @DESCRIPTION:
77# Default options for patch 165# Default options for patch:
166# @CODE
78# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 167# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
79# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 168# --no-backup-if-mismatch - do not leave .orig files behind
80# Set -E to automatically remove empty files. 169# -E - automatically remove empty files
170# @CODE
81EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 171EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
172# @VARIABLE: EPATCH_EXCLUDE
173# @DESCRIPTION:
82# List of patches not to apply. Not this is only file names, 174# List of patches not to apply. Note this is only file names,
83# and not the full path .. 175# and not the full path. Globs accepted.
84EPATCH_EXCLUDE="" 176EPATCH_EXCLUDE=""
177# @VARIABLE: EPATCH_SINGLE_MSG
178# @DESCRIPTION:
85# Change the printed message for a single patch. 179# Change the printed message for a single patch.
86EPATCH_SINGLE_MSG="" 180EPATCH_SINGLE_MSG=""
181# @VARIABLE: EPATCH_MULTI_MSG
182# @DESCRIPTION:
87# Change the printed message for multiple patches. 183# Change the printed message for multiple patches.
88EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 184EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
89# Force applying bulk patches even if not following the style: 185# @VARIABLE: EPATCH_FORCE
90# 186# @DESCRIPTION:
91# ??_${ARCH}_foo.${EPATCH_SUFFIX} 187# Only require patches to match EPATCH_SUFFIX rather than the extended
92# 188# arch naming style.
93EPATCH_FORCE="no" 189EPATCH_FORCE="no"
94 190
95# This function is for bulk patching, or in theory for just one 191# @FUNCTION: epatch
96# or two patches. 192# @USAGE: [patches] [dirs of patches]
193# @DESCRIPTION:
194# epatch is designed to greatly simplify the application of patches. It can
195# process patch files directly, or directories of patches. The patches may be
196# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
197# the -p option as epatch will automatically attempt -p0 to -p5 until things
198# apply successfully.
97# 199#
98# It should work with .bz2, .gz, .zip and plain text patches. 200# If you do not specify any options, then epatch will default to the directory
99# Currently all patches should be the same format. 201# specified by EPATCH_SOURCE.
100# 202#
101# You do not have to specify '-p' option to patch, as it will 203# When processing directories, epatch will apply all patches that match:
102# try with -p0 to -p5 until it succeed, or fail at -p5. 204# @CODE
103# 205# ${EPATCH_FORCE} == "yes"
104# Above EPATCH_* variables can be used to control various defaults,
105# bug they should be left as is to ensure an ebuild can rely on
106# them for.
107#
108# Patches are applied in current directory.
109#
110# Bulk Patches should preferibly have the form of:
111#
112# ??_${ARCH}_foo.${EPATCH_SUFFIX} 206# ??_${ARCH}_foo.${EPATCH_SUFFIX}
207# else
208# *.${EPATCH_SUFFIX}
209# @CODE
210# The leading ?? are typically numbers used to force consistent patch ordering.
211# The arch field is used to apply patches only for the host architecture with
212# the special value of "all" means apply for everyone. Note that using values
213# other than "all" is highly discouraged -- you should apply patches all the
214# time and let architecture details be detected at configure/compile time.
113# 215#
114# For example: 216# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
217# for patches to apply.
115# 218#
116# 01_all_misc-fix.patch.bz2 219# Refer to the other EPATCH_xxx variables for more customization of behavior.
117# 02_sparc_another-fix.patch.bz2
118#
119# This ensures that there are a set order, and you can have ARCH
120# specific patches.
121#
122# If you however give an argument to epatch(), it will treat it as a
123# single patch that need to be applied if its a file. If on the other
124# hand its a directory, it will set EPATCH_SOURCE to this.
125#
126# <azarah@gentoo.org> (10 Nov 2002)
127#
128epatch() { 220epatch() {
129 _epatch_draw_line() { 221 _epatch_draw_line() {
222 # create a line of same length as input string
130 [[ -z $1 ]] && set "$(printf "%65s" '')" 223 [[ -z $1 ]] && set "$(printf "%65s" '')"
131 echo "${1//?/=}" 224 echo "${1//?/=}"
132 } 225 }
133 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
134 local PIPE_CMD=""
135 local STDERR_TARGET="${T}/$$.out"
136 local PATCH_TARGET="${T}/$$.patch"
137 local PATCH_SUFFIX=""
138 local SINGLE_PATCH="no"
139 local x=""
140 226
141 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 227 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
142 228
143 if [ "$#" -gt 1 ] 229 # Let the rest of the code process one user arg at a time --
144 then 230 # each arg may expand into multiple patches, and each arg may
231 # need to start off with the default global EPATCH_xxx values
232 if [[ $# -gt 1 ]] ; then
145 local m="" 233 local m
146 for m in "$@" ; do 234 for m in "$@" ; do
147 epatch "${m}" 235 epatch "${m}"
148 done 236 done
149 return 0 237 return 0
150 fi 238 fi
151 239
152 if [ -n "$1" -a -f "$1" ] 240 local SINGLE_PATCH="no"
153 then 241 # no args means process ${EPATCH_SOURCE}
242 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
243
244 if [[ -f $1 ]] ; then
154 SINGLE_PATCH="yes" 245 SINGLE_PATCH="yes"
155 246 set -- "$1"
156 local EPATCH_SOURCE="$1" 247 # Use the suffix from the single patch (localize it); the code
248 # below will find the suffix for us
157 local EPATCH_SUFFIX="${1##*\.}" 249 local EPATCH_SUFFIX=$1
158 250
159 elif [ -n "$1" -a -d "$1" ] 251 elif [[ -d $1 ]] ; then
160 then 252 # Some people like to make dirs of patches w/out suffixes (vim)
161 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 253 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
162 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 254
255 else
256 # sanity check ... if it isn't a dir or file, wtf man ?
257 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
258 echo
259 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
260 eerror
261 eerror " ${EPATCH_SOURCE}"
262 eerror " ( ${EPATCH_SOURCE##*/} )"
263 echo
264 die "Cannot find \$EPATCH_SOURCE!"
265 fi
266
267 local PIPE_CMD
268 case ${EPATCH_SUFFIX##*\.} in
269 xz) PIPE_CMD="xz -dc" ;;
270 lzma) PIPE_CMD="lzma -dc" ;;
271 bz2) PIPE_CMD="bzip2 -dc" ;;
272 gz|Z|z) PIPE_CMD="gzip -dc" ;;
273 ZIP|zip) PIPE_CMD="unzip -p" ;;
274 *) ;;
275 esac
276
277 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
278
279 local x
280 for x in "$@" ; do
281 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
282 # didn't match anything, ignore continue on
283 [[ ! -f ${x} ]] && continue
284
285 local patchname=${x##*/}
286
287 # Apply single patches, or forced sets of patches, or
288 # patches with ARCH dependant names.
289 # ???_arch_foo.patch
290 # Else, skip this input altogether
291 local a=${patchname#*_} # strip the ???_
292 a=${a%%_*} # strip the _foo.patch
293 if ! [[ ${SINGLE_PATCH} == "yes" || \
294 ${EPATCH_FORCE} == "yes" || \
295 ${a} == all || \
296 ${a} == ${ARCH} ]]
163 then 297 then
164 local EPATCH_SOURCE="$1/*" 298 continue
299 fi
300
301 # Let people filter things dynamically
302 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
303 # let people use globs in the exclude
304 eshopts_push -o noglob
305
306 local ex
307 for ex in ${EPATCH_EXCLUDE} ; do
308 if [[ ${patchname} == ${ex} ]] ; then
309 eshopts_pop
310 continue 2
311 fi
312 done
313
314 eshopts_pop
315 fi
316
317 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
318 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
319 einfo "${EPATCH_SINGLE_MSG}"
320 else
321 einfo "Applying ${patchname} ..."
322 fi
165 else 323 else
166 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 324 einfo " ${patchname} ..."
167 fi 325 fi
168 else 326
169 if [[ ! -d ${EPATCH_SOURCE} ]] || [[ -n $1 ]] ; then 327 # most of the time, there will only be one run per unique name,
170 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 328 # but if there are more, make sure we get unique log filenames
171 then 329 local STDERR_TARGET="${T}/${patchname}.out"
172 EPATCH_SOURCE="$1" 330 if [[ -e ${STDERR_TARGET} ]] ; then
331 STDERR_TARGET="${T}/${patchname}-$$.out"
332 fi
333
334 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
335
336 # Decompress the patch if need be
337 local count=0
338 local PATCH_TARGET
339 if [[ -n ${PIPE_CMD} ]] ; then
340 PATCH_TARGET="${T}/$$.patch"
341 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
342
343 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
344 echo
345 eerror "Could not extract patch!"
346 #die "Could not extract patch!"
347 count=5
348 break
173 fi 349 fi
350 else
351 PATCH_TARGET=${x}
352 fi
174 353
354 # Check for absolute paths in patches. If sandbox is disabled,
355 # people could (accidently) patch files in the root filesystem.
356 # Or trigger other unpleasantries #237667. So disallow -p0 on
357 # such patches.
358 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
359 if [[ -n ${abs_paths} ]] ; then
360 count=1
361 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
362 fi
363
364 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
365 while [[ ${count} -lt 5 ]] ; do
366 # Generate some useful debug info ...
367 (
368 _epatch_draw_line "***** ${patchname} *****"
175 echo 369 echo
176 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 370 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
371 echo
372 _epatch_draw_line "***** ${patchname} *****"
373 ) >> "${STDERR_TARGET}"
374
375 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
376 (
377 _epatch_draw_line "***** ${patchname} *****"
378 echo
379 echo "ACTUALLY APPLYING ${patchname} ..."
380 echo
381 _epatch_draw_line "***** ${patchname} *****"
382 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
383 ) >> "${STDERR_TARGET}"
384
385 if [ $? -ne 0 ] ; then
386 echo
387 eerror "A dry-run of patch command succeeded, but actually"
388 eerror "applying the patch failed!"
389 #die "Real world sux compared to the dreamworld!"
390 count=5
391 fi
392 break
393 fi
394
395 : $(( count++ ))
396 done
397
398 # if we had to decompress the patch, delete the temp one
399 if [[ -n ${PIPE_CMD} ]] ; then
400 rm -f "${PATCH_TARGET}"
401 fi
402
403 if [[ ${count} -ge 5 ]] ; then
404 echo
405 eerror "Failed Patch: ${patchname} !"
406 eerror " ( ${PATCH_TARGET} )"
177 eerror 407 eerror
178 eerror " ${EPATCH_SOURCE}" 408 eerror "Include in your bugreport the contents of:"
179 eerror " ( ${EPATCH_SOURCE##*/} )" 409 eerror
410 eerror " ${STDERR_TARGET}"
180 echo 411 echo
181 die "Cannot find \$EPATCH_SOURCE!"
182 fi
183
184 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
185 fi
186
187 case ${EPATCH_SUFFIX##*\.} in
188 bz2)
189 PIPE_CMD="bzip2 -dc"
190 PATCH_SUFFIX="bz2"
191 ;;
192 gz|Z|z)
193 PIPE_CMD="gzip -dc"
194 PATCH_SUFFIX="gz"
195 ;;
196 ZIP|zip)
197 PIPE_CMD="unzip -p"
198 PATCH_SUFFIX="zip"
199 ;;
200 *)
201 PIPE_CMD="cat"
202 PATCH_SUFFIX="patch"
203 ;;
204 esac
205
206 if [ "${SINGLE_PATCH}" = "no" ]
207 then
208 einfo "${EPATCH_MULTI_MSG}"
209 fi
210 for x in ${EPATCH_SOURCE}
211 do
212 # New ARCH dependant patch naming scheme ...
213 #
214 # ???_arch_foo.patch
215 #
216 if [ -f ${x} ] && \
217 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
218 [ "${EPATCH_FORCE}" = "yes" ])
219 then
220 local count=0
221 local popts="${EPATCH_OPTS}"
222 local patchname=${x##*/}
223
224 if [ -n "${EPATCH_EXCLUDE}" ]
225 then
226 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
227 then
228 continue
229 fi
230 fi
231
232 if [ "${SINGLE_PATCH}" = "yes" ]
233 then
234 if [ -n "${EPATCH_SINGLE_MSG}" ]
235 then
236 einfo "${EPATCH_SINGLE_MSG}"
237 else
238 einfo "Applying ${patchname} ..."
239 fi
240 else
241 einfo " ${patchname} ..."
242 fi
243
244 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
245 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
246
247 # Allow for prefix to differ ... im lazy, so shoot me :/
248 while [ "${count}" -lt 5 ]
249 do
250 # Generate some useful debug info ...
251 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
252 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
253
254 if [ "${PATCH_SUFFIX}" != "patch" ]
255 then
256 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
257 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
258 else
259 PATCH_TARGET="${x}"
260 fi
261
262 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
263 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
264
265 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
266 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
267
268 if [ "${PATCH_SUFFIX}" != "patch" ]
269 then
270 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
271 then
272 echo
273 eerror "Could not extract patch!"
274 #die "Could not extract patch!"
275 count=5
276 break
277 fi
278 fi
279
280 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
281 then
282 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
283 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
284 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
285 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
286 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
287
288 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
289 _epatch_assert
290
291 if [ "$?" -ne 0 ]
292 then
293 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
294 echo
295 eerror "A dry-run of patch command succeeded, but actually"
296 eerror "applying the patch failed!"
297 #die "Real world sux compared to the dreamworld!"
298 count=5
299 fi
300
301 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
302
303 break
304 fi
305
306 count=$((count + 1))
307 done
308
309 if [ "${PATCH_SUFFIX}" != "patch" ]
310 then
311 rm -f ${PATCH_TARGET}
312 fi
313
314 if [ "${count}" -eq 5 ]
315 then
316 echo
317 eerror "Failed Patch: ${patchname} !"
318 eerror " ( ${PATCH_TARGET} )"
319 eerror
320 eerror "Include in your bugreport the contents of:"
321 eerror
322 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
323 echo
324 die "Failed Patch: ${patchname}!" 412 die "Failed Patch: ${patchname}!"
325 fi 413 fi
326 414
327 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 415 # if everything worked, delete the patch log
328 416 rm -f "${STDERR_TARGET}"
329 eend 0 417 eend 0
330 fi
331 done 418 done
332 if [ "${SINGLE_PATCH}" = "no" ] 419
333 then 420 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
334 einfo "Done with patching" 421 : # everything worked
422}
423epatch_user() {
424 [[ $# -ne 0 ]] && die "epatch_user takes no options"
425
426 # don't clobber any EPATCH vars that the parent might want
427 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
428 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
429 EPATCH_SOURCE=${base}/${CTARGET}/${check}
430 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
431 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
432 if [[ -d ${EPATCH_SOURCE} ]] ; then
433 EPATCH_SOURCE=${EPATCH_SOURCE} \
434 EPATCH_SUFFIX="patch" \
435 EPATCH_FORCE="yes" \
436 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
437 epatch
438 return 0
335 fi 439 fi
440 done
441 return 1
336} 442}
337 443
338# @FUNCTION: emktemp 444# @FUNCTION: emktemp
339# @USAGE: [temp dir] 445# @USAGE: [temp dir]
340# @DESCRIPTION: 446# @DESCRIPTION:
376# base-system@gentoo.org (Linux) 482# base-system@gentoo.org (Linux)
377# Joe Jezak <josejx@gmail.com> (OS X) 483# Joe Jezak <josejx@gmail.com> (OS X)
378# usata@gentoo.org (OS X) 484# usata@gentoo.org (OS X)
379# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD) 485# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
380# @DESCRIPTION: 486# @DESCRIPTION:
381# Small wrapper for getent (Linux), nidump (Mac OS X), 487# Small wrapper for getent (Linux),
488# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
382# and pw (FreeBSD) used in enewuser()/enewgroup() 489# and pw (FreeBSD) used in enewuser()/enewgroup()
383egetent() { 490egetent() {
384 case ${CHOST} in 491 case ${CHOST} in
385 *-darwin*) 492 *-darwin[678])
386 case "$2" in 493 case "$2" in
387 *[!0-9]*) # Non numeric 494 *[!0-9]*) # Non numeric
388 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 495 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
389 ;; 496 ;;
390 *) # Numeric 497 *) # Numeric
391 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 498 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
499 ;;
500 esac
501 ;;
502 *-darwin*)
503 local mytype=$1
504 [[ "passwd" == $mytype ]] && mytype="Users"
505 [[ "group" == $mytype ]] && mytype="Groups"
506 case "$2" in
507 *[!0-9]*) # Non numeric
508 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
509 ;;
510 *) # Numeric
511 local mykey="UniqueID"
512 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
513 dscl . -search /$mytype $mykey $2 2>/dev/null
392 ;; 514 ;;
393 esac 515 esac
394 ;; 516 ;;
395 *-freebsd*|*-dragonfly*) 517 *-freebsd*|*-dragonfly*)
396 local opts action="user" 518 local opts action="user"
596 fi 718 fi
597 ;; 719 ;;
598 720
599 *) 721 *)
600 if [[ -z $@ ]] ; then 722 if [[ -z $@ ]] ; then
601 useradd ${opts} ${euser} \ 723 useradd -r ${opts} \
602 -c "added by portage for ${PN}" \ 724 -c "added by portage for ${PN}" \
725 ${euser} \
603 || die "enewuser failed" 726 || die "enewuser failed"
604 else 727 else
605 einfo " - Extra: $@" 728 einfo " - Extra: $@"
606 useradd ${opts} ${euser} "$@" \ 729 useradd -r ${opts} "$@" \
730 ${euser} \
607 || die "enewuser failed" 731 || die "enewuser failed"
608 fi 732 fi
609 ;; 733 ;;
610 esac 734 esac
611 735
723 esac 847 esac
724 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 848 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
725 ;; 849 ;;
726 850
727 *) 851 *)
852 # We specify -r so that we get a GID in the system range from login.defs
728 groupadd ${opts} ${egroup} || die "enewgroup failed" 853 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
729 ;; 854 ;;
730 esac 855 esac
731 export SANDBOX_ON="${oldsandbox}" 856 export SANDBOX_ON="${oldsandbox}"
732} 857}
733 858
744 869
745# Make a desktop file ! 870# Make a desktop file !
746# Great for making those icons in kde/gnome startmenu ! 871# Great for making those icons in kde/gnome startmenu !
747# Amaze your friends ! Get the women ! Join today ! 872# Amaze your friends ! Get the women ! Join today !
748# 873#
749# make_desktop_entry(<command>, [name], [icon], [type], [path]) 874# make_desktop_entry(<command>, [name], [icon], [type], [fields])
750# 875#
751# binary: what command does the app run with ? 876# binary: what command does the app run with ?
752# name: the name that will show up in the menu 877# name: the name that will show up in the menu
753# icon: give your little like a pretty little icon ... 878# icon: give your little like a pretty little icon ...
754# this can be relative (to /usr/share/pixmaps) or 879# this can be relative (to /usr/share/pixmaps) or
755# a full path to an icon 880# a full path to an icon
756# type: what kind of application is this ? for categories: 881# type: what kind of application is this ? for categories:
757# http://standards.freedesktop.org/menu-spec/latest/apa.html 882# http://standards.freedesktop.org/menu-spec/latest/apa.html
758# path: if your app needs to startup in a specific dir 883# fields: extra fields to append to the desktop file; a printf string
759make_desktop_entry() { 884make_desktop_entry() {
760 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 885 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
761 886
762 local exec=${1} 887 local exec=${1}
763 local name=${2:-${PN}} 888 local name=${2:-${PN}}
764 local icon=${3:-${PN}} 889 local icon=${3:-${PN}}
765 local type=${4} 890 local type=${4}
766 local path=${5} 891 local fields=${5}
767 892
768 if [[ -z ${type} ]] ; then 893 if [[ -z ${type} ]] ; then
769 local catmaj=${CATEGORY%%-*} 894 local catmaj=${CATEGORY%%-*}
770 local catmin=${CATEGORY##*-} 895 local catmin=${CATEGORY##*-}
771 case ${catmaj} in 896 case ${catmaj} in
772 app) 897 app)
773 case ${catmin} in 898 case ${catmin} in
774 accessibility) type=Accessibility;; 899 accessibility) type=Accessibility;;
775 admin) type=System;; 900 admin) type=System;;
776 antivirus) type=System;; 901 antivirus) type=System;;
777 arch) type=Archiving;; 902 arch) type=Archiving;;
778 backup) type=Archiving;; 903 backup) type=Archiving;;
779 cdr) type=DiscBurning;; 904 cdr) type=DiscBurning;;
780 dicts) type=Dictionary;; 905 dicts) type=Dictionary;;
781 doc) type=Documentation;; 906 doc) type=Documentation;;
782 editors) type=TextEditor;; 907 editors) type=TextEditor;;
783 emacs) type=TextEditor;; 908 emacs) type=TextEditor;;
784 emulation) type=Emulator;; 909 emulation) type=Emulator;;
785 laptop) type=HardwareSettings;; 910 laptop) type=HardwareSettings;;
786 office) type=Office;; 911 office) type=Office;;
787 pda) type=PDA;; 912 pda) type=PDA;;
788 vim) type=TextEditor;; 913 vim) type=TextEditor;;
789 xemacs) type=TextEditor;; 914 xemacs) type=TextEditor;;
790 *) type=;;
791 esac 915 esac
792 ;; 916 ;;
793 917
794 dev) 918 dev)
795 type="Development" 919 type="Development"
796 ;; 920 ;;
797 921
798 games) 922 games)
799 case ${catmin} in 923 case ${catmin} in
800 action|fps) type=ActionGame;; 924 action|fps) type=ActionGame;;
801 arcade) type=ArcadeGame;; 925 arcade) type=ArcadeGame;;
802 board) type=BoardGame;; 926 board) type=BoardGame;;
803 emulation) type=Emulator;; 927 emulation) type=Emulator;;
804 kids) type=KidsGame;; 928 kids) type=KidsGame;;
805 puzzle) type=LogicGame;; 929 puzzle) type=LogicGame;;
806 roguelike) type=RolePlaying;; 930 roguelike) type=RolePlaying;;
807 rpg) type=RolePlaying;; 931 rpg) type=RolePlaying;;
808 simulation) type=Simulation;; 932 simulation) type=Simulation;;
809 sports) type=SportsGame;; 933 sports) type=SportsGame;;
810 strategy) type=StrategyGame;; 934 strategy) type=StrategyGame;;
811 *) type=;;
812 esac 935 esac
813 type="Game;${type}" 936 type="Game;${type}"
814 ;; 937 ;;
815 938
816 gnome) 939 gnome)
825 type="Network;Email" 948 type="Network;Email"
826 ;; 949 ;;
827 950
828 media) 951 media)
829 case ${catmin} in 952 case ${catmin} in
953 gfx)
830 gfx) type=Graphics;; 954 type=Graphics
955 ;;
956 *)
957 case ${catmin} in
831 radio) type=Tuner;; 958 radio) type=Tuner;;
832 sound) type=Audio;; 959 sound) type=Audio;;
833 tv) type=TV;; 960 tv) type=TV;;
834 video) type=Video;; 961 video) type=Video;;
835 *) type=;; 962 esac
963 type="AudioVideo;${type}"
964 ;;
836 esac 965 esac
837 type="AudioVideo;${type}"
838 ;; 966 ;;
839 967
840 net) 968 net)
841 case ${catmin} in 969 case ${catmin} in
842 dialup) type=Dialup;; 970 dialup) type=Dialup;;
843 ftp) type=FileTransfer;; 971 ftp) type=FileTransfer;;
844 im) type=InstantMessaging;; 972 im) type=InstantMessaging;;
845 irc) type=IRCClient;; 973 irc) type=IRCClient;;
846 mail) type=Email;; 974 mail) type=Email;;
847 news) type=News;; 975 news) type=News;;
848 nntp) type=News;; 976 nntp) type=News;;
849 p2p) type=FileTransfer;; 977 p2p) type=FileTransfer;;
850 *) type=;; 978 voip) type=Telephony;;
851 esac 979 esac
852 type="Network;${type}" 980 type="Network;${type}"
853 ;; 981 ;;
854 982
855 sci) 983 sci)
856 case ${catmin} in 984 case ${catmin} in
857 astro*) type=Astronomy;; 985 astro*) type=Astronomy;;
858 bio*) type=Biology;; 986 bio*) type=Biology;;
859 calc*) type=Calculator;; 987 calc*) type=Calculator;;
860 chem*) type=Chemistry;; 988 chem*) type=Chemistry;;
861 elec*) type=Electronics;; 989 elec*) type=Electronics;;
862 geo*) type=Geology;; 990 geo*) type=Geology;;
863 math*) type=Math;; 991 math*) type=Math;;
864 physics) type=Physics;; 992 physics) type=Physics;;
865 visual*) type=DataVisualization;; 993 visual*) type=DataVisualization;;
866 *) type=;;
867 esac 994 esac
868 type="Science;${type}" 995 type="Education;Science;${type}"
869 ;; 996 ;;
870 997
871 sys) 998 sys)
872 type="System" 999 type="System"
873 ;; 1000 ;;
874 1001
875 www) 1002 www)
876 case ${catmin} in 1003 case ${catmin} in
877 client) type=WebBrowser;; 1004 client) type=WebBrowser;;
878 *) type=;;
879 esac 1005 esac
880 type="Network" 1006 type="Network;${type}"
881 ;; 1007 ;;
882 1008
883 *) 1009 *)
884 type= 1010 type=
885 ;; 1011 ;;
891 local desktop_name="${PN}-${SLOT}" 1017 local desktop_name="${PN}-${SLOT}"
892 fi 1018 fi
893 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 1019 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
894 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 1020 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
895 1021
1022 # Don't append another ";" when a valid category value is provided.
1023 type=${type%;}${type:+;}
1024
1025 eshopts_push -s extglob
1026 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1027 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1028 ewarn "allowed in .desktop files if the value is not an absolute path."
1029 icon=${icon%.@(xpm|png|svg)}
1030 fi
1031 eshopts_pop
1032
896 cat <<-EOF > "${desktop}" 1033 cat <<-EOF > "${desktop}"
897 [Desktop Entry] 1034 [Desktop Entry]
898 Version=1.0
899 Name=${name} 1035 Name=${name}
900 Type=Application 1036 Type=Application
901 Comment=${DESCRIPTION} 1037 Comment=${DESCRIPTION}
902 Exec=${exec} 1038 Exec=${exec}
903 TryExec=${exec%% *} 1039 TryExec=${exec%% *}
904 Icon=${icon} 1040 Icon=${icon}
905 Categories=${type}; 1041 Categories=${type}
906 EOF 1042 EOF
907 1043
908 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 1044 if [[ ${fields:-=} != *=* ]] ; then
1045 # 5th arg used to be value to Path=
1046 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1047 fields="Path=${fields}"
1048 fi
1049 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
909 1050
910 ( 1051 (
911 # wrap the env here so that the 'insinto' call 1052 # wrap the env here so that the 'insinto' call
912 # doesn't corrupt the env of the caller 1053 # doesn't corrupt the env of the caller
913 insinto /usr/share/applications 1054 insinto /usr/share/applications
914 doins "${desktop}" 1055 doins "${desktop}"
915 ) 1056 ) || die "installing desktop file failed"
916} 1057}
917 1058
918# @FUNCTION: validate_desktop_entries 1059# @FUNCTION: validate_desktop_entries
919# @USAGE: [directories] 1060# @USAGE: [directories]
920# @MAINTAINER: 1061# @MAINTAINER:
942 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 1083 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
943 fi 1084 fi
944} 1085}
945 1086
946# @FUNCTION: make_session_desktop 1087# @FUNCTION: make_session_desktop
947# @USAGE: <title> <command> 1088# @USAGE: <title> <command> [command args...]
948# @DESCRIPTION: 1089# @DESCRIPTION:
949# Make a GDM/KDM Session file. The title is the file to execute to start the 1090# Make a GDM/KDM Session file. The title is the file to execute to start the
950# Window Manager. The command is the name of the Window Manager. 1091# Window Manager. The command is the name of the Window Manager.
1092#
1093# You can set the name of the file via the ${wm} variable.
951make_session_desktop() { 1094make_session_desktop() {
952 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 1095 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
953 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 1096 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
954 1097
955 local title=$1 1098 local title=$1
956 local command=$2 1099 local command=$2
957 local desktop=${T}/${wm}.desktop 1100 local desktop=${T}/${wm:-${PN}}.desktop
1101 shift 2
958 1102
959 cat <<-EOF > "${desktop}" 1103 cat <<-EOF > "${desktop}"
960 [Desktop Entry] 1104 [Desktop Entry]
961 Name=${title} 1105 Name=${title}
962 Comment=This session logs you into ${title} 1106 Comment=This session logs you into ${title}
963 Exec=${command} 1107 Exec=${command} $*
964 TryExec=${command} 1108 TryExec=${command}
965 Type=Application 1109 Type=XSession
966 EOF 1110 EOF
967 1111
968 ( 1112 (
969 # wrap the env here so that the 'insinto' call 1113 # wrap the env here so that the 'insinto' call
970 # doesn't corrupt the env of the caller 1114 # doesn't corrupt the env of the caller
1196 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1340 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1197 1341
1198 local shrtsrc=$(basename "${src}") 1342 local shrtsrc=$(basename "${src}")
1199 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1343 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1200 if [[ -z ${skip} ]] ; then 1344 if [[ -z ${skip} ]] ; then
1201 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1345 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1202 local skip=0 1346 local skip=0
1203 exe=tail 1347 exe=tail
1204 case ${ver} in 1348 case ${ver} in
1205 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1349 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1206 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1350 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1208 2.0|2.0.1) 1352 2.0|2.0.1)
1209 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1353 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1210 ;; 1354 ;;
1211 2.1.1) 1355 2.1.1)
1212 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1356 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1213 let skip="skip + 1" 1357 (( skip++ ))
1214 ;; 1358 ;;
1215 2.1.2) 1359 2.1.2)
1216 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1360 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1217 let skip="skip + 1" 1361 (( skip++ ))
1218 ;; 1362 ;;
1219 2.1.3) 1363 2.1.3)
1220 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1364 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1221 let skip="skip + 1" 1365 (( skip++ ))
1222 ;; 1366 ;;
1223 2.1.4|2.1.5) 1367 2.1.4|2.1.5)
1224 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1368 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1225 skip=$(head -n ${skip} "${src}" | wc -c) 1369 skip=$(head -n ${skip} "${src}" | wc -c)
1226 exe="dd" 1370 exe="dd"
1235 esac 1379 esac
1236 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1380 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1237 fi 1381 fi
1238 case ${exe} in 1382 case ${exe} in
1239 tail) exe="tail -n +${skip} '${src}'";; 1383 tail) exe="tail -n +${skip} '${src}'";;
1240 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1384 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1241 *) die "makeself cant handle exe '${exe}'" 1385 *) die "makeself cant handle exe '${exe}'"
1242 esac 1386 esac
1243 1387
1244 # lets grab the first few bytes of the file to figure out what kind of archive it is 1388 # lets grab the first few bytes of the file to figure out what kind of archive it is
1245 local tmpfile=$(emktemp) 1389 local tmpfile=$(emktemp)
1282 lic="${PWD}/${lic}" 1426 lic="${PWD}/${lic}"
1283 elif [ -e "${lic}" ] ; then 1427 elif [ -e "${lic}" ] ; then
1284 lic="${lic}" 1428 lic="${lic}"
1285 fi 1429 fi
1286 fi 1430 fi
1287 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1288 local l="`basename ${lic}`" 1431 local l="`basename ${lic}`"
1289 1432
1290 # here is where we check for the licenses the user already 1433 # here is where we check for the licenses the user already
1291 # accepted ... if we don't find a match, we make the user accept 1434 # accepted ... if we don't find a match, we make the user accept
1292 local shopts=$-
1293 local alic 1435 local alic
1294 set -o noglob #so that bash doesn't expand "*" 1436 eshopts_push -o noglob # so that bash doesn't expand "*"
1295 for alic in ${ACCEPT_LICENSE} ; do 1437 for alic in ${ACCEPT_LICENSE} ; do
1296 if [[ ${alic} == ${l} ]]; then 1438 if [[ ${alic} == ${l} ]]; then
1297 set +o noglob; set -${shopts} #reset old shell opts 1439 eshopts_pop
1298 return 0 1440 return 0
1299 fi 1441 fi
1300 done 1442 done
1301 set +o noglob; set -$shopts #reset old shell opts 1443 eshopts_pop
1444 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1302 1445
1303 local licmsg=$(emktemp) 1446 local licmsg=$(emktemp)
1304 cat <<-EOF > ${licmsg} 1447 cat <<-EOF > ${licmsg}
1305 ********************************************************** 1448 **********************************************************
1306 The following license outlines the terms of use of this 1449 The following license outlines the terms of use of this
1379 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1522 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1380 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1523 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1381 export CDROM_SET=-1 1524 export CDROM_SET=-1
1382 for f in ${CDROM_CHECK_1//:/ } ; do 1525 for f in ${CDROM_CHECK_1//:/ } ; do
1383 ((++CDROM_SET)) 1526 ((++CDROM_SET))
1384 [[ -e ${CD_ROOT}/${f} ]] && break 1527 [[ -e ${CDROM_ROOT}/${f} ]] && break
1385 done 1528 done
1386 export CDROM_MATCH=${f} 1529 export CDROM_MATCH=${f}
1387 return 1530 return
1388 fi 1531 fi
1389 1532
1553# of the lists. 1696# of the lists.
1554strip-linguas() { 1697strip-linguas() {
1555 local ls newls nols 1698 local ls newls nols
1556 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1699 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1557 local op=$1; shift 1700 local op=$1; shift
1558 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1701 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1559 local d f 1702 local d f
1560 for d in "$@" ; do 1703 for d in "$@" ; do
1561 if [[ ${op} == "-u" ]] ; then 1704 if [[ ${op} == "-u" ]] ; then
1562 newls=${ls} 1705 newls=${ls}
1563 else 1706 else
1564 newls="" 1707 newls=""
1565 fi 1708 fi
1566 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1709 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1567 if [[ ${op} == "-i" ]] ; then 1710 if [[ ${op} == "-i" ]] ; then
1568 hasq ${f} ${ls} && newls="${newls} ${f}" 1711 hasq ${f} ${ls} && newls="${newls} ${f}"
1569 else 1712 else
1570 hasq ${f} ${ls} || newls="${newls} ${f}" 1713 hasq ${f} ${ls} || newls="${newls} ${f}"
1571 fi 1714 fi
1584 else 1727 else
1585 nols="${nols} ${f}" 1728 nols="${nols} ${f}"
1586 fi 1729 fi
1587 done 1730 done
1588 [[ -n ${nols} ]] \ 1731 [[ -n ${nols} ]] \
1589 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1732 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1590 export LINGUAS=${newls:1} 1733 export LINGUAS=${newls:1}
1591} 1734}
1592 1735
1593# @FUNCTION: preserve_old_lib 1736# @FUNCTION: preserve_old_lib
1594# @USAGE: <libs to preserve> [more libs] 1737# @USAGE: <libs to preserve> [more libs]
1647 ewarn " # revdep-rebuild --library ${lib##*/}" 1790 ewarn " # revdep-rebuild --library ${lib##*/}"
1648 done 1791 done
1649 if [[ ${notice} -eq 1 ]] ; then 1792 if [[ ${notice} -eq 1 ]] ; then
1650 ewarn 1793 ewarn
1651 ewarn "Once you've finished running revdep-rebuild, it should be safe to" 1794 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1652 ewarn "delete the old libraries." 1795 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1796 for lib in "$@" ; do
1797 ewarn " # rm '${lib}'"
1798 done
1653 fi 1799 fi
1654} 1800}
1655 1801
1656# @FUNCTION: built_with_use 1802# @FUNCTION: built_with_use
1657# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1803# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1658# @DESCRIPTION: 1804# @DESCRIPTION:
1805#
1806# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1807#
1659# A temporary hack until portage properly supports DEPENDing on USE 1808# A temporary hack until portage properly supports DEPENDing on USE
1660# flags being enabled in packages. This will check to see if the specified 1809# flags being enabled in packages. This will check to see if the specified
1661# DEPEND atom was built with the specified list of USE flags. The 1810# DEPEND atom was built with the specified list of USE flags. The
1662# --missing option controls the behavior if called on a package that does 1811# --missing option controls the behavior if called on a package that does
1663# not actually support the defined USE flags (aka listed in IUSE). 1812# not actually support the defined USE flags (aka listed in IUSE).
1664# The default is to abort (call die). The -a and -o flags control 1813# The default is to abort (call die). The -a and -o flags control
1665# the requirements of the USE flags. They correspond to "and" and "or" 1814# the requirements of the USE flags. They correspond to "and" and "or"
1666# logic. So the -a flag means all listed USE flags must be enabled 1815# logic. So the -a flag means all listed USE flags must be enabled
1667# while the -o flag means at least one of the listed fIUSE flags must be 1816# while the -o flag means at least one of the listed IUSE flags must be
1668# enabled. The --hidden option is really for internal use only as it 1817# enabled. The --hidden option is really for internal use only as it
1669# means the USE flag we're checking is hidden expanded, so it won't be found 1818# means the USE flag we're checking is hidden expanded, so it won't be found
1670# in IUSE like normal USE flags. 1819# in IUSE like normal USE flags.
1671# 1820#
1672# Remember that this function isn't terribly intelligent so order of optional 1821# Remember that this function isn't terribly intelligent so order of optional
1707 die) die "Unable to determine what USE flags $PKG was built with";; 1856 die) die "Unable to determine what USE flags $PKG was built with";;
1708 esac 1857 esac
1709 fi 1858 fi
1710 1859
1711 if [[ ${hidden} == "no" ]] ; then 1860 if [[ ${hidden} == "no" ]] ; then
1712 local IUSE_BUILT=$(<${IUSEFILE}) 1861 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1713 # Don't check USE_EXPAND #147237 1862 # Don't check USE_EXPAND #147237
1714 local expand 1863 local expand
1715 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do 1864 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1716 if [[ $1 == ${expand}_* ]] ; then 1865 if [[ $1 == ${expand}_* ]] ; then
1717 expand="" 1866 expand=""
1718 break 1867 break
1719 fi 1868 fi
1720 done 1869 done
1721 if [[ -n ${expand} ]] ; then 1870 if [[ -n ${expand} ]] ; then
1722 if ! has $1 ${IUSE_BUILT} ; then 1871 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1723 case ${missing_action} in 1872 case ${missing_action} in
1724 true) return 0;; 1873 true) return 0;;
1725 false) return 1;; 1874 false) return 1;;
1726 die) die "$PKG does not actually support the $1 USE flag!";; 1875 die) die "$PKG does not actually support the $1 USE flag!";;
1727 esac 1876 esac
1791 ) || die 1940 ) || die
1792 else 1941 else
1793 newbin "${tmpwrapper}" "${wrapper}" || die 1942 newbin "${tmpwrapper}" "${wrapper}" || die
1794 fi 1943 fi
1795} 1944}
1945
1946# @FUNCTION: prepalldocs
1947# @USAGE:
1948# @DESCRIPTION:
1949# Compress files in /usr/share/doc which are not already
1950# compressed, excluding /usr/share/doc/${PF}/html.
1951# Uses the ecompressdir to do the compression.
1952# 2009-02-18 by betelgeuse:
1953# Commented because ecompressdir is even more internal to
1954# Portage than prepalldocs (it's not even mentioned in man 5
1955# ebuild). Please submit a better version for review to gentoo-dev
1956# if you want prepalldocs here.
1957#prepalldocs() {
1958# if [[ -n $1 ]] ; then
1959# ewarn "prepalldocs: invalid usage; takes no arguments"
1960# fi
1961
1962# cd "${D}"
1963# [[ -d usr/share/doc ]] || return 0
1964
1965# find usr/share/doc -exec gzip {} +
1966# ecompressdir --ignore /usr/share/doc/${PF}/html
1967# ecompressdir --queue /usr/share/doc
1968#}

Legend:
Removed from v.1.299  
changed lines
  Added in v.1.349

  ViewVC Help
Powered by ViewVC 1.1.20